;
; ram.asm - zeropage related
;
; Written by
;  Kajtar Zsolt <soci@c64.rulez.org>
;
;    This file is part of IDEDOS the IDE64 disk operating system
;    See README for copyright notice.
;
;    This program is free software; you can redistribute it and/or modify
;    it under the terms of the GNU General Public License as published by
;    the Free Software Foundation; either version 2 of the License, or
;    (at your option) any later version.
;
;    This program is distributed in the hope that it will be useful,
;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;    GNU General Public License for more details.
;
;    You should have received a copy of the GNU General Public License
;    along with this program; if not, write to the Free Software
;    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
;
		#opencfg_start
;----------------------------------
;Restore zeropage if needed
;
OP_restore_zeropage_if_needed .proc
		lda zp_valid_exp
		beq cxf
;----------------------------------
;Restore zeropage
;
OP_restore_zeropage .proc
		ldx #(end_zeropage-start_zeropage)/2
zal2		lda zp_exp-1,x
		sta start_zeropage-1,x
		lda zp_exp-1+(end_zeropage-start_zeropage)/2,x
		sta start_zeropage-1+(end_zeropage-start_zeropage)/2,x
		dex
		bne zal2
		lda zp_valid_exp
		.if DEBUG=1
		beq zp_bug
		.fi
		#stx_l_a zp_valid_exp
cxf		.global
		rts
		.pend
;----------------------------------
;Handle zeropage bug
;
		.if DEBUG=1
zp_bug		.proc
		.if SUPERCPU=0
		jmp debugzp
		.else
		brk
		.fi
		.pend
		.fi
;----------------------------------
;Save zeropage
;
		.if (end_zeropage-start_zeropage) & 1
		.error "zeropagesize!"
		.fi

OP_save_zeropage .proc
		ldx #(end_zeropage-start_zeropage)/2
zal1		lda start_zeropage-1,x
		sta zp_exp-1,x
		lda start_zeropage-1+(end_zeropage-start_zeropage)/2,x
		sta zp_exp-1+(end_zeropage-start_zeropage)/2,x
		dex
		bne zal1
		.if DEBUG=1
		lda zp_valid_exp
		bne zp_bug
		.fi
		lda #1
		sta zp_valid_exp
		rts
		.pend
;----------------------------------
;Load next_sector
;
OP_load_next_sector_now .proc
		lda buffer_now_head_exp,x
		sta next_sector
		lda buffer_now_cylhi_exp,x
		sta next_sector+1
		lda buffer_now_cyllow_exp,x
		sta next_sector+2
		lda buffer_now_sector_exp,x
		sta next_sector+3
		rts
		.pend
;----------------------------------
;Save next_sector
;
OP_save_next_sector_now .proc
		lda next_sector
		sta buffer_now_head_exp,x
		lda next_sector+1
		sta buffer_now_cylhi_exp,x
		lda next_sector+2
		sta buffer_now_cyllow_exp,x
		lda next_sector+3
		sta buffer_now_sector_exp,x
		rts
		.pend
;----------------------------------
;Load next_sector
;
OP_load_next_sector_treep .proc
		#ldatax buffer_currentp_exp
OP_load_next_sector_tree .proc
		lda buffer_tree_head_exp,x
		sta next_sector
		lda buffer_tree_cylhi_exp,x
		sta next_sector+1
		lda buffer_tree_cyllow_exp,x
		sta next_sector+2
		lda buffer_tree_sector_exp,x
		sta next_sector+3
		rts
		.pend
;----------------------------------
;Save next_sector
;
OP_save_next_sector_treep .proc
		#ldatax buffer_currentp_exp
OP_save_next_sector_tree .proc
		lda next_sector
		sta buffer_tree_head_exp,x
		lda next_sector+1
		sta buffer_tree_cylhi_exp,x
		lda next_sector+2
		sta buffer_tree_cyllow_exp,x
		lda next_sector+3
		sta buffer_tree_sector_exp,x
		rts
		.pend

		#opencfg_end
